using MySystem.Models.Main;
using Library;
using MySystem.Service.Main;
using System.Collections.Generic;
using System;
using LitJson;
using MySystem.Areas.Api.Controllers;
using System.Linq;

namespace MySystem
{
    /// <summary>
    /// 我的工具类
    /// </summary>
    public class MySelfUtil
    {
        public static string bankName = "";
        public static string cardNo = "";

        #region 到账记录列表
        /// <summary>
        /// 到账记录列表
        /// </summary>
        /// <param name="condition">查询条件</param>
        /// <param name="pageSize">条数</param>
        /// <param name="pageNum">页数</param>
        /// <returns></returns>
        public static List<Dictionary<string, object>> CardInComeRecordList(int MerchantId, string TradeMonth, string pageSize, string pageNum)
        {
            Dictionary<string, object> ListInfo = GetInfo();
            bool check = false;
            DateTime start = new DateTime(int.Parse(TradeMonth.Substring(0, 4)), int.Parse(TradeMonth.Substring(TradeMonth.Length - 2, 2)), 1);
            DateTime end = start.AddMonths(1).AddDays(-1);
            var merchantInfo = MerchantAddInfoService.Query(MerchantId);
            JsonData Info = JsonMapper.ToObject(HaoDaHelper.Instance.CardInComeRecord(merchantInfo.OutMchtNo, start.ToString("yyyy-MM-dd"), end.ToString("yyyy-MM-dd"), merchantInfo.MchtNo, "", "", pageNum, pageSize, merchantInfo.BrandId));
            List<Dictionary<string, object>> dataList = new List<Dictionary<string, object>>();
            if (Info["code"].ToString() == "0")
            {
                var list = Info["data"]["list"];
                for (int i = 0; i < list.Count; i++)
                {
                    Dictionary<string, object> curData = new Dictionary<string, object>();
                    var item = list[i];
                    if (item["settleAccountName"].ToString() != "四川省润观米科技有限公司")
                    {
                        curData.Add("Id", item["id"].ToString()); //订单Id
                        curData.Add("SettleStatus", item["settleStatus"].ToString()); //结算状态(0: 入账成功、1: 入账失败、2: 结算超时、3: 入账受理成功、4: 已提交结算请求、5:已拆分批次、6: 初始化批次信息、7:正在提交结算请求)
                        curData.Add("SettleDate", item["settleDate"].ToString().Substring(item["settleDate"].ToString().Length - 5, 5)); //结算日期
                        curData.Add("SettleAmount", (decimal.Parse(item["settleAmount"].ToString()) / 100).ToString("f2")); //结算金额
                        curData.Add("TradeMchtName", item["tradeMchtName"].ToString()); //收单商户名称
                        curData.Add("BankName", item["bankName"].ToString()); //开户行名称
                        bankName = item["bankName"].ToString();
                        cardNo = item["cardNo"].ToString().Substring(item["cardNo"].ToString().Length - 4, 4);
                        dataList.Add(curData);
                        if (ListInfo.ContainsKey(MerchantId + "|" + "2023-11-23") && check == false && item["settleDate"].ToString() == "2023-11-23")
                        {
                            check = true;
                            var info = ListInfo[MerchantId + "|" + "2023-11-23"];
                            Dictionary<string, object> curDatas = new Dictionary<string, object>();
                            curDatas.Add("Id", "0"); //订单Id
                            curDatas.Add("SettleStatus", "0"); //结算状态(0: 入账成功、1: 入账失败、2: 结算超时、3: 入账受理成功、4: 已提交结算请求、5:已拆分批次、6: 初始化批次信息、7:正在提交结算请求)
                            curDatas.Add("SettleDate", "11-23"); //结算日期
                            curDatas.Add("SettleAmount", info); //结算金额
                            curDatas.Add("TradeMchtName", merchantInfo.CertMerchantName); //收单商户名称
                            curDatas.Add("BankName", bankName); //开户行名称
                            dataList.Add(curDatas);
                        }
                    }
                }
            }
            return dataList;
        }
        #endregion


        #region 到账记录详情
        /// <summary>
        /// 到账记录详情
        /// </summary>
        /// <param name="condition">查询条件</param>
        /// <param name="pageSize">条数</param>
        /// <param name="pageNum">页数</param>
        /// <returns></returns>
        public static Dictionary<string, object> CardInComeRecordDetail(int MerchantId, string OrderId)
        {
            Dictionary<string, object> ListInfo = GetInfo();
            var merchantInfo = MerchantAddInfoService.Query(MerchantId);
            if (OrderId == "0")
            {
                Dictionary<string, object> objs = new Dictionary<string, object>();
                objs.Add("Id", "16661513739247493123" + MerchantId); //订单Id
                objs.Add("SettleStatus", "0"); //结算状态(0: 入账成功、1: 入账失败、2: 结算超时、3: 入账受理成功、4: 已提交结算请求、5:已拆分批次、6: 初始化批次信息、7:正在提交结算请求)
                objs.Add("SettleType", "D1"); //结算周期
                objs.Add("SettleDate", "2023-11-23"); //结算日期
                objs.Add("ClearTime", "2023-11-23 10:06:43"); //出款受理时间
                objs.Add("RemitTime", "2023-11-23 11:08:22"); //出款成功时间
                var info = ListInfo[MerchantId + "|" + "2023-11-23"];
                objs.Add("SettleAmount", info); //结算金额
                objs.Add("TradeMchtName", merchantInfo.CertMerchantName); //收单商户名称
                objs.Add("BankName", bankName + "(" + cardNo + ")"); //开户行名称
                objs.Add("FailureReason", ""); //出款失败备注
                return objs;
            }
            else
            {
                JsonData Info = JsonMapper.ToObject(HaoDaHelper.Instance.CardInComeDetail(merchantInfo.OutMchtNo, OrderId, merchantInfo.BrandId));
                Dictionary<string, object> obj = new Dictionary<string, object>();
                if (Info["code"].ToString() == "0")
                {
                    obj.Add("Id", Info["data"]["id"].ToString()); //订单Id
                    obj.Add("SettleStatus", Info["data"]["settleStatus"].ToString()); //结算状态(0: 入账成功、1: 入账失败、2: 结算超时、3: 入账受理成功、4: 已提交结算请求、5:已拆分批次、6: 初始化批次信息、7:正在提交结算请求)
                    obj.Add("SettleType", Info["data"]["settleType"].ToString()); //结算周期
                    obj.Add("SettleDate", Info["data"]["settleDate"].ToString()); //结算日期
                    obj.Add("ClearTime", Info["data"]["clearTime"].ToString()); //出款受理时间
                    obj.Add("RemitTime", Info["data"]["remitTime"].ToString()); //出款成功时间
                    obj.Add("SettleAmount", (decimal.Parse(Info["data"]["settleAmount"].ToString()) / 100).ToString("f2")); //结算金额
                    obj.Add("TradeMchtName", Info["data"]["tradeMchtName"].ToString()); //收单商户名称
                    obj.Add("BankName", Info["data"]["bankName"].ToString() + "(" + Info["data"]["cardNo"].ToString().Substring(Info["data"]["cardNo"].ToString().Length - 4, 4) + ")"); //开户行名称
                    obj.Add("FailureReason", Info["data"]["remark"].ToString()); //出款失败备注
                }
                return obj;
            }
        }
        #endregion

        #region 我的-设置-修改登录手机号(新手机验证)
        /// <summary>
        /// 我的-设置-修改登录手机号(新手机验证)
        /// </summary>
        /// <param name="LoginMobile">原手机号</param>
        /// <param name="Mobile">新手机号</param>
        /// <returns></returns>
        public static string ChangeLoginMobile(string LoginMobile, string Mobile)
        {
            var info = MerchantLoginInfoService.Query(" and LoginMobile=" + LoginMobile + "");
            if (info.Id > 0)
            {
                Dictionary<string, object> obj = new Dictionary<string, object>();
                obj.Add("LoginMobile", Mobile);
                MerchantLoginInfoService.Edit(obj, info.Id);
            }
            return "修改成功";
        }
        #endregion


        #region 商户统计数据（个人中心主界面）
        /// <summary>
        /// 商户统计数据（个人中心主界面）
        /// </summary>
        /// <param name="MerchantId">商户Id</param>
        /// <returns></returns>
        public static Dictionary<string, object> StatData(int MerchantId)
        {
            Dictionary<string, object> Obj = new Dictionary<string, object>();
            var query = MerchantInfoService.Query(MerchantId);
            Obj.Add("Name", query.Name); //名称
            Obj.Add("TotalAmount", query.TotalAmount.ToString("f2")); //营收总金额
            Obj.Add("TotalActual", query.TotalActual.ToString("f2")); //实收总金额
            var yesterday = DateTime.Now.AddDays(-1).ToString("yyyyMMdd");
            // Obj.Add("YesterDayActual", decimal.Parse(function.CheckNum(UserTradeDbconn.Instance.GetTrade(MerchantId, yesterday, "InFactAmount")["InFactAmount"].ToString())).ToString("f2")); //昨日收入
            Obj.Add("YesterDayActual", decimal.Parse(MerchantAmountSummayService.Sum("TotalActual", " and MerchantId=" + MerchantId + " and TradeDate='" + yesterday + "'")["TotalActual"]).ToString("f2")); //昨日收入
            Obj.Add("SettleAmount", 0.00); //待结算金额
            Obj.Add("TotalOrder", query.TotalConsumeCount); //累计订单
            Obj.Add("TotalCustomer", query.TotalCustomer); //累计客户
            Obj.Add("Logo", BaseController.DefaultPic(query.Logo)); //Logo图片
            int ConsumeCount = 0;
            decimal WeChatTotal = 0;
            decimal AlipayTotal = 0;
            for (int i = 0; i < 7; i++)
            {
                string Date = DateTime.Now.AddDays(-i).ToString("yyyyMMdd");
                WeChatTotal += decimal.Parse(MerchantAmountSummayService.Sum("TotalActual", " and MerchantId=" + MerchantId + " and PayMode=2 and TradeDate='" + Date + "'")["TotalActual"]);
                AlipayTotal += decimal.Parse(MerchantAmountSummayService.Sum("TotalActual", " and MerchantId=" + MerchantId + " and PayMode=1 and TradeDate='" + Date + "'")["TotalActual"]);
            }
            Obj.Add("SevenDayConsumer", ConsumeCount); //近7日新增会员
            Obj.Add("WeChatTotal", WeChatTotal.ToString("f2")); //微信实收
            Obj.Add("AlipayTotal", AlipayTotal.ToString("f2")); //支付宝实收
            Obj.Add("CreateDate", query.CreateDate == null ? "" : query.CreateDate.Value.ToString("yyyy-MM-dd"));
            return Obj;
        }
        #endregion

        public static Dictionary<string, object> GetInfo()
        {
            Dictionary<string, object> ListInfo = new Dictionary<string, object>();
            ListInfo.Add("1272|2023-11-23", 7762.17);
            ListInfo.Add("974|2023-11-23", 36.91);
            ListInfo.Add("1415|2023-11-23", 195.02);
            ListInfo.Add("1307|2023-11-23", 94.64);
            ListInfo.Add("1176|2023-11-23", 50.39);
            ListInfo.Add("1648|2023-11-23", 390.95);
            ListInfo.Add("878|2023-11-23", 101.91);
            ListInfo.Add("862|2023-11-23", 23.7);
            ListInfo.Add("1191|2023-11-23", 36.12);
            ListInfo.Add("955|2023-11-23", 6.43);
            ListInfo.Add("982|2023-11-23", 10.14);
            ListInfo.Add("1466|2023-11-23", 378.91);
            ListInfo.Add("1115|2023-11-23", 189.61);
            ListInfo.Add("1343|2023-11-23", 131.36);
            ListInfo.Add("1586|2023-11-23", 350.45);
            ListInfo.Add("1410|2023-11-23", 7.67);
            ListInfo.Add("1505|2023-11-23", 438.03);
            ListInfo.Add("1219|2023-11-23", 115.13);
            ListInfo.Add("1293|2023-11-23", 6.02);
            ListInfo.Add("1093|2023-11-23", 66.01);
            ListInfo.Add("1300|2023-11-23", 51.78);
            ListInfo.Add("1593|2023-11-23", 11.17);
            ListInfo.Add("1602|2023-11-23", 131.11);
            ListInfo.Add("1595|2023-11-23", 70.09);
            ListInfo.Add("1265|2023-11-23", 432.92);
            ListInfo.Add("1032|2023-11-23", 60.13);
            ListInfo.Add("1551|2023-11-23", 18.62);
            ListInfo.Add("1578|2023-11-23", 213.98);
            ListInfo.Add("1400|2023-11-23", 362.89);
            ListInfo.Add("1640|2023-11-23", 562.67);
            ListInfo.Add("1331|2023-11-23", 53.08);
            ListInfo.Add("1591|2023-11-23", 258.33);
            ListInfo.Add("460|2023-11-23", 100.22);
            ListInfo.Add("1547|2023-11-23", 701.9);
            ListInfo.Add("1447|2023-11-23", 76.48);
            ListInfo.Add("1147|2023-11-23", 20.73);
            ListInfo.Add("1388|2023-11-23", 3.57);
            ListInfo.Add("1399|2023-11-23", 312.1);
            ListInfo.Add("1284|2023-11-23", 76.11);
            ListInfo.Add("1211|2023-11-23", 280.19);
            ListInfo.Add("1259|2023-11-23", 150.73);
            ListInfo.Add("999|2023-11-23", 40.58);
            ListInfo.Add("1116|2023-11-23", 13.55);
            ListInfo.Add("1597|2023-11-23", 213.29);
            ListInfo.Add("1295|2023-11-23", 219.75);
            ListInfo.Add("1554|2023-11-23", 793.93);
            ListInfo.Add("1634|2023-11-23", 45.69);
            ListInfo.Add("1493|2023-11-23", 168.84);
            ListInfo.Add("1430|2023-11-23", 377.74);
            ListInfo.Add("994|2023-11-23", 2260.74);
            ListInfo.Add("1569|2023-11-23", 174.96);
            ListInfo.Add("1439|2023-11-23", 61.26);
            ListInfo.Add("1409|2023-11-23", 253.94);
            ListInfo.Add("1440|2023-11-23", 370.55);
            ListInfo.Add("945|2023-11-23", 404.93);
            ListInfo.Add("1475|2023-11-23", 3.53);
            ListInfo.Add("1464|2023-11-23", 121.87);
            ListInfo.Add("1534|2023-11-23", 62.67);
            ListInfo.Add("1587|2023-11-23", 9110.39);
            ListInfo.Add("1492|2023-11-23", 213.31);
            ListInfo.Add("1627|2023-11-23", 214.43);
            ListInfo.Add("1158|2023-11-23", 6.77);
            ListInfo.Add("1646|2023-11-23", 67.72);
            ListInfo.Add("1630|2023-11-23", 3.01);
            ListInfo.Add("1445|2023-11-23", 285.21);
            ListInfo.Add("1521|2023-11-23", 479.66);
            ListInfo.Add("1563|2023-11-23", 1072.17);
            ListInfo.Add("1441|2023-11-23", 1119.27);
            ListInfo.Add("867|2023-11-23", 355.51);
            ListInfo.Add("868|2023-11-23", 228.68);
            return ListInfo;
        }


    }
}